function y1 = EulerStep(f,y0,t0,h)
%EULERSTEP step of explicit Euler method
%   Y1 = EULERSTEP(F,Y0,T0,H) computes the approximate solution Y1 at time
%   T0+H using one step of the explicit Euler method starting at Y0.  F 
%   should be a function handle taking the arguments (t,y) and returning a 
%   column vector corresponding to f(t,y).

% C.J. Gittelson / SAM ETHZ / 2008

y1 = y0 + h*f(t0,y0);

return