% Explicit Euler, implicit Euler and Symplectic Implicit Euler method

% Define problem and discretization parameters
y0= ;
T =  ;
h = 0.05;
tol = 1e-6;

% Define right hand side  p -> y(1) and q-> y(2) 
f = @(t,y)  ;

% Call Explicit Euler and Implicit Euler for (11.1.2) and (11.1.3)
[t,yExp] = EulerSolve(f,y0,T,h);
[t,yImp] = ImpEulerSolve(f,y0,T,h,tol);

% Call ImpEulerSymplecticStep for (11.1.4)
[t,yImpSymp] =  ;

% Calculate I(p,q) for all these three different algorithms

Inva_exp = ;
Inva_imp = ;
Inva_impsym = ;


%Plot solution in phase space
figure(1)
plot(yExp(1,:),yExp(2,:),'bo-');
hold on;
plot(yImp(1,:),yImp(2,:),'r^-');
plot(yImpSymp(1,:),yImpSymp(2,:),...
     'gx-','MarkerSize',16);
hold off;
title(['\bf Numerical Methods for a Hamitonian system, T=' num2str(T(2)) ...
      ' h=' num2str(h)]);
legend('explicit Euler (2)','implicit Euler (3)','Symplectic Euler (4)');
xlabel('p');
ylabel('q');
set(gca,'XLim',[0 3]);
set(gca,'YLim',[0.5 4.5]);

% Plot the trajectory of I(p,q)
figure;
plot(t,Inva_exp);
hold on;
plot(t,Inva_imp);
plot(t,Inva_impsym);
legend('explicit Euler', 'implicit Euler', 'Symplectic Euler');
title('Trajectory of Invariance I(p,q) under different algorithms');
xlabel('t');
ylabel('I');
